/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.ctmrcardiovascularanalysisreporttemplates;

import cdac.medinfo.sdk.dcm30_04.baselibs.ContentSequenceItem;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.SRDocumentContentModule;
import cdac.medinfo.sdk.dcm30_04.enums.EnumContinuityOfContent;
import cdac.medinfo.sdk.dcm30_04.srtree.SRTree;
import cdac.medinfo.sdk.dcm30_04.templates.cathlabclinicalreporttemplate.CardiovascularPatientHistory_TID3802;
import cdac.medinfo.sdk.dcm30_04.templates.cid.NonInvasiveVascularProcedures_CID3820;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_CTMRCardiovascularAnalysisReport;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_NonInvasiveVascularProcedures;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_CTMRCardiovascularAnalysisReport;
import cdac.medinfo.sdk.dcm30_04.templates.generaltemplates.LanguageOfContentItemAndDescendants_TID1204;
import cdac.medinfo.sdk.dcm30_04.templates.generaltemplates.ObservationContext_TID1001;
import cdac.medinfo.sdk.dcm30_04.templates.generaltemplates.Template;

/**
 * This class represents CTMRCardiovascularAnalysisReport_TID3900
 */
public class CTMRCardiovascularAnalysisReport_TID3900 extends Template
{
	private static final String strCM = null;

	/**
	 * Object of NonInvasiveVascularProcedures_CID3820
	 */

	private NonInvasiveVascularProcedures_CID3820 objNonInvasiveVascularProceduresCID3820;

	/**
	 * Object of LanguageOfContentItemAndDescendants_TID1204
	 */

	private LanguageOfContentItemAndDescendants_TID1204 objLanguageOfContentItemAndDescendantsTID1204;

	/**
	 * Object of ObservationContext_TID1001
	 */

	private ObservationContext_TID1001 objObservationContextTID1001;

	/**
	 * Object of CardiovascularPatientHistory_TID3802
	 */

	private CardiovascularPatientHistory_TID3802 objCardiovascularPatientHistoryTID3802;

	/**
	 * Object of ProcedureSummary_TID3901
	 */

	private ProcedureSummary_TID3901 objProcedureSummaryTID3901;
	
	/**
	 * Object of VascularAnalysis_TID3902
	 */
	private VascularAnalysis_TID3902 objVascularAnalysisTID3902;
	
	/**
	 * Object of VentricularAnalysis_TID3920
	 */
	private VentricularAnalysis_TID3920 objVentricularAnalysisTID3920;
	
	/**
	 * Object of ReportSummary_TID3927
	 */
	private ReportSummary_TID3927 objReportSummaryTID3927;
	
	/**
	 * Instantiates a new CTMRCardiovascularAnalysisReport_TID3900 Template.
	 * @param objTree Object of SRTree.
	 */
	public CTMRCardiovascularAnalysisReport_TID3900(SRTree objTree)
	{
		super(objTree);
	}

	/**
	 * Retrieves ReportSummary 
	 * @return objReportSummaryTID3927 Object of ReportSummary_TID3927 
	 */
	public ReportSummary_TID3927 getReportSummary() 
	{
		if(null == this.objReportSummaryTID3927)
			this.objReportSummaryTID3927 = new ReportSummary_TID3927(getSRTree());
		return this.objReportSummaryTID3927;
	}

	/**
	 * Retrieves Ventricular Analysis.
	 * @return objVentricularAnalysisTID3920 Object of VentricularAnalysis_TID3920 
	 */
	public VentricularAnalysis_TID3920 getVentricularAnalysis() 
	{
		if(null == this.objVentricularAnalysisTID3920)
			this.objVentricularAnalysisTID3920 = new VentricularAnalysis_TID3920(getSRTree());
		return this.objVentricularAnalysisTID3920;
	}
	/**
	 * Retrieves Vascular Analysis
	 * @return objVascularAnalysisTID3902 Object of VascularAnalysis_TID3902 
	 */
	public VascularAnalysis_TID3902 getVascularAnalysis() 
	{
		if(null == this.objVascularAnalysisTID3902)
			this.objVascularAnalysisTID3902 = new VascularAnalysis_TID3902(getSRTree());
		return this.objVascularAnalysisTID3902;
	}
	/**
	 * Retrieves Procedure Summary.
	 * @return objProcedureSummaryTID3901 Object of ProcedureSummary_TID3901 
	 */
	public ProcedureSummary_TID3901 getProcedureSummary()
	{
		if(null == this.objProcedureSummaryTID3901)
			this.objProcedureSummaryTID3901 = new ProcedureSummary_TID3901(getSRTree());
		return this.objProcedureSummaryTID3901;
	}
	
	/**
	 * Retrieves Cardiovascular Patient History.
	 * @return objCardiovascularPatientHistoryTID3802 Object of CardiovascularPatientHistory_TID3802 
	 */
	public CardiovascularPatientHistory_TID3802 getCardiovascularPatientHistory() 
	{
		if(null == this.objCardiovascularPatientHistoryTID3802)
			this.objCardiovascularPatientHistoryTID3802 = new CardiovascularPatientHistory_TID3802(getSRTree());
		return this.objCardiovascularPatientHistoryTID3802;
	}

	/**
	 * Retrieves Observation Context.
	 * @return objObservationContextTID1001 Object of ObservationContext_TID1001 
	 */
	public ObservationContext_TID1001 getObservationContext() 
	{
		if(null == this.objObservationContextTID1001)
			this.objObservationContextTID1001 = new ObservationContext_TID1001(getSRTree());
		return this.objObservationContextTID1001;
	}

	/**
	 * Retrieves LanguageOfContentItemAndDescendants.
	 * @return objLanguageOfContentItemAndDescendantsTID1204 Object of LanguageOfContentItemAndDescendants_TID1204 
	 */
	public LanguageOfContentItemAndDescendants_TID1204 getLanguageOfContentItemAndDescendants() 
	{
		if(null == this.objLanguageOfContentItemAndDescendantsTID1204)
			this.objLanguageOfContentItemAndDescendantsTID1204 = new LanguageOfContentItemAndDescendants_TID1204(getSRTree());
		return this.objLanguageOfContentItemAndDescendantsTID1204;
	}

	/**
	 * Sets the value for CardiovascularAnalysisReport.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param enumContinuityOfContent Enumerated Value for ContinuityOfContent.
	 */
	public void setCardiovascularAnalysisReport(EnumContinuityOfContent enumContinuityOfContent)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CTMRCardiovascularAnalysisReport.CARDIOVASCULAR_ANALYSIS_REPORT.getValue();
		String strCodeValue = EnumCV_CTMRCardiovascularAnalysisReport.CARDIOVASCULAR_ANALYSIS_REPORT_122600.getValue();
		String strCSD = EnumCodingSchemeDesignator.DCM.getValue();

		/**
		 * Creating a node of Value Type CONTAINER and adding this node as root of a tree.
		 */
		SRDocumentContentModule objDocumentContentModule = getSRTree().getSRDocumentContentModule();
		getSRTree().createRoot(objDocumentContentModule,strCodeMeaning,strCodeValue , strCSD, enumContinuityOfContent);
	}
	
	/**
	 * Sets the value for ProcedureReported.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param strProcedureActionID String value for Procedure Action ID
	 */
	public void setProcedureReported(int[] arrPosition, EnumCM_NonInvasiveVascularProcedures enumNonInvasiveVascularProcedures)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CTMRCardiovascularAnalysisReport.PROCEDURE_REPORTED.getValue();
		String strCodeValue = EnumCV_CTMRCardiovascularAnalysisReport.PROCEDURE_REPORTED_121058.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.DCM.getValue();
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		if(null== this.objNonInvasiveVascularProceduresCID3820)
			this.objNonInvasiveVascularProceduresCID3820 = new NonInvasiveVascularProcedures_CID3820();
		this.objNonInvasiveVascularProceduresCID3820.setNonInvasiveVascularProcedures(enumNonInvasiveVascularProcedures);

		String strCM = objNonInvasiveVascularProceduresCID3820.getCodeMeaning();
		String strCV = objNonInvasiveVascularProceduresCID3820.getCodeValue();
		String strCSD = objNonInvasiveVascularProceduresCID3820.getCodingSchemeDesignator();
		String strSNOMEDCTID = objNonInvasiveVascularProceduresCID3820.getSNOMEDCTID();
		
		/**
		 * Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, strCV, strCSDesg, "", strCM,strSNOMEDCTID);
		getSRTree().addChild(objContentSequenceItem);
	}

}

